package stackjava.com.httpcomponentsdownload.demo;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.fluent.Request;
import org.apache.http.client.fluent.Response;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.HttpClients;

public class DemoDownload {

	public static void downloadFile1(String filePath, String urlDownload) throws ClientProtocolException, IOException {
		File fileDownload = new File(filePath);
		Response response = Request.Get(urlDownload).execute();
		response.saveContent(fileDownload);
	}

	public static void downloadFile2(String filePath, String urlDownload) throws ClientProtocolException, IOException {
		File fileDownload = new File(filePath);
		Response response = Request.Get(urlDownload).execute();
		HttpResponse httpResponse = response.returnResponse();
		InputStream is = httpResponse.getEntity().getContent();
		FileOutputStream fos = new FileOutputStream(fileDownload);
		int inByte;
		while ((inByte = is.read()) != -1) {
			fos.write(inByte);
		}
		is.close();
		fos.close();

	}

	public static void downloadFile3(String filePath, String urlDownload) throws ClientProtocolException, IOException {
		File fileDownload = new File(filePath);
		HttpGet httpGet = new HttpGet(urlDownload);
		HttpClient client = HttpClients.createDefault();
		HttpResponse httpResponse = client.execute(httpGet);

		InputStream is = httpResponse.getEntity().getContent();
		FileOutputStream fos = new FileOutputStream(fileDownload);
		int inByte;
		while ((inByte = is.read()) != -1) {
			fos.write(inByte);
		}
		is.close();
		fos.close();
	}

	public static void main(String[] args) throws ClientProtocolException, IOException {
		File folderDownload = new File(System.getProperty("user.home") + "/Downloads");
		if (!folderDownload.exists()) {
			folderDownload.mkdirs();
		}
		String urlDownload = "https://stackjava.com/wp-content/uploads/2018/05/SpringBootDownloadFile.zip";
		downloadFile1(folderDownload+"/file1.zip", urlDownload);
		downloadFile2(folderDownload+"/file2.zip", urlDownload);
		downloadFile3(folderDownload+"/file3.zip", urlDownload);
	}
}
